#include "ehm.h"
#include "ui_ehm.h"
#include <QMessageBox>
#include <math.h>

QString onceki;
QString islem;
QString silinecek;
bool sifirVar=false;
bool virgulVar=false;
bool islemVar=false;
bool ilkSayi=true;
bool mevcutToplama=false;
bool mevcutCikarma=false;
bool mevcutCarpma=false;
bool mevcutBolme=false;
bool mevcutEsittir=false;
double sayi2=0;
double sayi1=0;
double sonuc=0;
double sonucK=0;
QString sonucKS="0";
double oncekiDouble=0;
double fakt=1;
const double pi=3.14159265;

#if defined(__OS2__)
  #define log2(value) log((double)value)/log(2.0)
#endif

ehm::ehm(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::ehm)
{
    ui->setupUi(this);
    ui->groupBox1->hide();
    layout()->setSizeConstraint(QLayout::SetFixedSize);
    connect(ui->btnGizle,SIGNAL(clicked()),this,SLOT(fonkGizle()));
    connect(ui->btn1,SIGNAL(clicked()),this,SLOT(fonkbtn1()));
    connect(ui->btn2,SIGNAL(clicked()),this,SLOT(fonkbtn2()));
    connect(ui->btn3,SIGNAL(clicked()),this,SLOT(fonkbtn3()));
    connect(ui->btn4,SIGNAL(clicked()),this,SLOT(fonkbtn4()));
    connect(ui->btn5,SIGNAL(clicked()),this,SLOT(fonkbtn5()));
    connect(ui->btn6,SIGNAL(clicked()),this,SLOT(fonkbtn6()));
    connect(ui->btn7,SIGNAL(clicked()),this,SLOT(fonkbtn7()));
    connect(ui->btn8,SIGNAL(clicked()),this,SLOT(fonkbtn8()));
    connect(ui->btn9,SIGNAL(clicked()),this,SLOT(fonkbtn9()));
    connect(ui->btn0,SIGNAL(clicked()),this,SLOT(fonkbtn0()));
    connect(ui->btnVirgul,SIGNAL(clicked()),this,SLOT(fonkVirgul()));
    connect(ui->btnTemizle,SIGNAL(clicked()),this,SLOT(fonkTemizle()));
    connect(ui->btnToplama,SIGNAL(clicked()),this,SLOT(fonkToplama()));
    connect(ui->btnCikarma,SIGNAL(clicked()),this,SLOT(fonkCikarma()));
    connect(ui->btnCarpma,SIGNAL(clicked()),this,SLOT(fonkCarpma()));
    connect(ui->btnBolme,SIGNAL(clicked()),this,SLOT(fonkBolme()));
    connect(ui->btnEsittir,SIGNAL(clicked()),this,SLOT(fonkEsittir()));
    connect(ui->btnGeriAl,SIGNAL(clicked()),this,SLOT(fonkGeriAl()));
    connect(ui->btnHakkinda,SIGNAL(clicked()),this,SLOT(fonkHakkinda()));
    connect(ui->btnIsaret,SIGNAL(clicked()),this,SLOT(fonkIsaret()));
    connect(ui->btnKarekok,SIGNAL(clicked()),this,SLOT(fonkKarekok()));
    connect(ui->btnYuzde,SIGNAL(clicked()),this,SLOT(fonkYuzde()));
    connect(ui->btn2us,SIGNAL(clicked()),this,SLOT(fonk2us()));
    connect(ui->btn1bolu,SIGNAL(clicked()),this,SLOT(fonk1bolu()));
    connect(ui->btnFakt,SIGNAL(clicked()),this,SLOT(fonkFakt()));
    connect(ui->btnSin,SIGNAL(clicked()),this,SLOT(fonkSin()));
    connect(ui->btnCos,SIGNAL(clicked()),this,SLOT(fonkCos()));
    connect(ui->btnTan,SIGNAL(clicked()),this,SLOT(fonkTan()));
    connect(ui->btnCot,SIGNAL(clicked()),this,SLOT(fonkCot()));
    connect(ui->btnPi,SIGNAL(clicked()),this,SLOT(fonkPi()));
    connect(ui->btnArcsin,SIGNAL(clicked()),this,SLOT(fonkArcsin()));
    connect(ui->btnArccos,SIGNAL(clicked()),this,SLOT(fonkArccos()));
    connect(ui->btnArctan,SIGNAL(clicked()),this,SLOT(fonkArctan()));
    connect(ui->btnArccot,SIGNAL(clicked()),this,SLOT(fonkArccot()));
    connect(ui->btnLog,SIGNAL(clicked()),this,SLOT(fonkLog()));
}

void ehm::fonkHakkinda()
{
    if(formHakkinda.isHidden()==true)
    {
        formHakkinda.show();
    }
    else
    {
        formHakkinda.hide();
    }
}

void ehm::fonkGizle()
{
    if(ui->groupBox1->isHidden()==true)
    {
        ui->groupBox1->show();
    }
    else
    {
        ui->groupBox1->hide();
    }
}

void ehm::fonkMevcutSifirla()
{
    mevcutToplama=false;
    mevcutCikarma=false;
    mevcutCarpma=false;
    mevcutBolme=false;
    mevcutEsittir=false;
}

void ehm::fonkbtn1()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
        ui->ekran->setText("1");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("1");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn2()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
       ui->ekran->setText("2");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("2");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn3()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
        ui->ekran->setText("3");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("3");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn4()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
        ui->ekran->setText("4");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("4");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn5()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
        ui->ekran->setText("5");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("5");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn6()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
        ui->ekran->setText("6");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("6");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn7()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
         ui->ekran->setText("7");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("7");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn8()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
        ui->ekran->setText("8");
    }
    else
    {
    onceki= ui->ekran->text();
    onceki.append("8");
    ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn9()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(sifirVar==true)
    {
        ui->ekran->setText("9");
    }
    else
    {
        onceki= ui->ekran->text();
        onceki.append("9");
        ui->ekran->setText(onceki);
    }
    sifirVar=false;
}

void ehm::fonkbtn0()
{
    fonkMevcutSifirla();
    if(islemVar==true)
    {
        ui->ekran->setText("");
        islemVar=false;
    }
    if(ui->ekran->text()=="")
    {
        ui->ekran->setText("0");
        sifirVar=true;
    }
    else if(sifirVar==false)
    {
        onceki=ui->ekran->text();
        onceki.append("0");
        ui->ekran->setText(onceki);
    }
}

void ehm::fonkVirgul()
{
    if(virgulVar==false && sonucKS=="0")
    {
        if(islemVar==true)
        {
            islemVar=false;
        }
        if(ui->ekran->text()=="")
        {
            ui->ekran->setText("0.");
            virgulVar=true;
        }
        else
        {
            onceki=ui->ekran->text();
            onceki.append(".");
            ui->ekran->setText(onceki);
            virgulVar=true;
        }
    }
    sifirVar=false;
}

void ehm::fonkTemizle()
{
    ui->ekran->setText("");
    ui->lblIslem->setText("");
    fonkMevcutSifirla();
    sifirVar=false;
    virgulVar=false;
    islemVar=false;
    ilkSayi=true;
    sayi2=0;
    sayi1=0;
    sonuc=0;
}

void ehm::fonkToplama()
{
    fonkEsittir();
    if(mevcutToplama==false)
    {
        if(islem!="toplama")
        {
            ilkSayi=true;
            ui->lblIslem->setText("+");
        }
        islem="toplama";
        islemVar=true;
        fonkIslem();
        mevcutToplama=true;
        mevcutEsittir=true;
    }
}

void ehm::fonkCikarma()
{
    fonkEsittir();
    if(mevcutCikarma==false)
    {
        if(islem!="cikarma")
        {
            ilkSayi=true;
            ui->lblIslem->setText("-");
        }
        islem="cikarma";
        islemVar=true;
        fonkIslem();
        mevcutCikarma=true;
        mevcutEsittir=true;
    }
}

void ehm::fonkCarpma()
{
    fonkEsittir();
    if(mevcutCarpma==false)
    {
        if(islem!="carpma")
        {
            ilkSayi=true;
            ui->lblIslem->setText("x");
        }
        islem="carpma";
        islemVar=true;
        fonkIslem();
        mevcutCarpma=true;
        mevcutEsittir=true;
    }
}

void ehm::fonkBolme()
{
    fonkEsittir();
    if(mevcutBolme==false)
    {
       if(islem!="bolme")
       {
           ilkSayi=true;
           ui->lblIslem->setText("/");
       }
       islem="bolme";
       islemVar=true;
       fonkIslem();
       mevcutBolme=true;
       mevcutEsittir=true;
   }
}

void ehm::fonkIslem()
{
    if(ilkSayi==true)
    {
        sayi1=ui->ekran->text().toDouble();
        ilkSayi=false;
    }
    else
    {
        sayi2=ui->ekran->text().toDouble();
        if(islem=="toplama")
        {
            sonuc=sayi1+sayi2;
        }
        else if(islem=="cikarma")
        {
            sonuc=sayi1-sayi2;
        }
        else if(islem=="carpma")
        {
            sonuc=sayi1*sayi2;
        }
        else if(islem=="bolme")
        {
            sonuc=sayi1/sayi2;
        }

        sonucK=sonuc;
        sonucK=sonucK*10;
        sonucKS=QString::number(sonucK);
        int size=sonucKS.size();
        sonucKS.remove(0,size-1);

        ui->ekran->setText(QString::number(sonuc));
        sayi1=sonuc;
    }
}

void ehm::fonkEsittir()
{
    if(mevcutEsittir==false)
    {
        ui->lblIslem->setText("=");
        fonkIslem();
    }
    mevcutEsittir=true;
    islemVar=true;
    virgulVar=false;
    ilkSayi=true;
    islem="";
}

void ehm::fonkGeriAl()
{
    ui->lblIslem->setText("<<");
    silinecek=ui->ekran->text();
    silinecek.chop(1);
    ui->ekran->setText(silinecek);
}

void ehm::fonkIsaret()
{
    oncekiDouble=ui->ekran->text().toDouble();
    if(oncekiDouble>0)
    {
        ui->lblIslem->setText("+/-");
        onceki=ui->ekran->text();
        onceki="-"+ onceki;
        ui->ekran->setText(onceki);
    }
    else if(oncekiDouble<0)
    {
        ui->lblIslem->setText("+/-");
        onceki=ui->ekran->text();
        onceki.remove(0,1);
        ui->ekran->setText(onceki);
    }
}

void ehm::fonkKarekok()
{
    ui->lblIslem->setText("");
    oncekiDouble=ui->ekran->text().toDouble();
    ui->ekran->setText(QString::number(sqrt(oncekiDouble)));
    islemVar=true;
}

void ehm::fonkYuzde()
{
    ui->lblIslem->setText("%");
    oncekiDouble=ui->ekran->text().toDouble();
    ui->ekran->setText(QString::number(oncekiDouble/100));
    islemVar=true;
}

void ehm::fonk2us()
{
    ui->lblIslem->setText("x^2");
    oncekiDouble=ui->ekran->text().toDouble();
    ui->ekran->setText(QString::number(oncekiDouble*oncekiDouble));
    islemVar=true;
}

void ehm::fonk1bolu()
{
    ui->lblIslem->setText("1/x");
    oncekiDouble=ui->ekran->text().toDouble();
    ui->ekran->setText(QString::number(1/oncekiDouble));
    islemVar=true;
}

void ehm::fonkFakt()
{
    fakt=1;
    fonkEsittir();
    ui->lblIslem->setText("x!");
    oncekiDouble=ui->ekran->text().toDouble();
    while(oncekiDouble>0)
    {
        fakt=fakt*oncekiDouble;
        oncekiDouble=oncekiDouble-1;
    }
    ui->ekran->setText(QString::number(fakt));
}

void ehm::fonkSin()
{
    islemVar=true;
    ui->lblIslem->setText("Sin");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/180;
    }
    else if(ui->rbtnRadyan->isChecked()==true){}
    else if(ui->rbtnGrad->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/200;
    }
    sonuc=sin(oncekiDouble);
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkCos()
{
    islemVar=true;
    ui->lblIslem->setText("Cos");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/180;
    }
    else if(ui->rbtnRadyan->isChecked()==true){}
    else if(ui->rbtnGrad->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/200;
    }
    sonuc=cos(oncekiDouble);
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkTan()
{
    islemVar=true;
    ui->lblIslem->setText("Tan");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/180;
    }
    else if(ui->rbtnRadyan->isChecked()==true){}
    else if(ui->rbtnGrad->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/200;
    }
    sonuc=tan(oncekiDouble);
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkCot()
{
    islemVar=true;
    ui->lblIslem->setText("Cot");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/180;
    }
    else if(ui->rbtnRadyan->isChecked()==true){}
    else if(ui->rbtnGrad->isChecked()==true)
    {
        oncekiDouble=(oncekiDouble*pi)/200;
    }
    sonuc=tan(oncekiDouble);
    sonuc=1/sonuc;
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkArcsin()
{
    islemVar=true;
    ui->lblIslem->setText("Arcsin");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        sonuc=asin(oncekiDouble)*180/pi;
    }
    else if(ui->rbtnRadyan->isChecked()==true)
    {
        sonuc=asin(oncekiDouble);
    }
    else if(ui->rbtnGrad->isChecked()==true)
    {
        sonuc=asin(oncekiDouble)*200/pi;
    }
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkArccos()
{
    islemVar=true;
    ui->lblIslem->setText("Arccos");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        sonuc=acos(oncekiDouble)*180/pi;
    }
    else if(ui->rbtnRadyan->isChecked()==true)
    {
        sonuc=acos(oncekiDouble);
    }
    else if(ui->rbtnGrad->isChecked()==true)
    {
        sonuc=acos(oncekiDouble)*200/pi;
    }
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkArctan()
{
    islemVar=true;
    ui->lblIslem->setText("Arctan");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        sonuc=atan(oncekiDouble)*180/pi;
    }
    else if(ui->rbtnRadyan->isChecked()==true)
    {
        sonuc=atan(oncekiDouble);
    }
    else if(ui->rbtnGrad->isChecked()==true)
    {
        sonuc=atan(oncekiDouble)*200/pi;
    }
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkArccot()
{
    islemVar=true;
    ui->lblIslem->setText("Arccot");
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnDerece->isChecked()==true)
    {
        sonuc=atan(oncekiDouble)*180/pi;
    }
    else if(ui->rbtnRadyan->isChecked()==true)
    {
        sonuc=atan(oncekiDouble);
    }
    else if(ui->rbtnGrad->isChecked()==true)
    {
        sonuc=atan(oncekiDouble)*200/pi;
    }
    sonuc=1/sonuc;
    ui->ekran->setText(QString::number(sonuc));
}

void ehm::fonkPi()
{
    ui->ekran->setText(QString::number(pi));
}

void ehm::fonkLog()
{
    islemVar=true;
    oncekiDouble=ui->ekran->text().toDouble();
    if(ui->rbtnT2->isChecked()==true)
    {
        sonuc=log2(oncekiDouble);
    }
    else if(ui->rbtnT10->isChecked()==true)
    {
        sonuc=log10(oncekiDouble);
    }
    else if(ui->rbtnTe->isChecked()==true)
    {
        sonuc=log(oncekiDouble);
    }
    ui->ekran->setText(QString::number(sonuc));
}

ehm::~ehm()
{
    delete ui;
}
